package com.fzm.common.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.fzm.common.entity.Nft;
import com.fzm.common.entity.vo.CollectionNftVo;

import java.util.List;

/**
 * @author tangtuo
 * @date 2021/6/30 15:55
 */
public interface NftService extends IService<Nft> {
    /**
     * 发行nft
     *
     * @param nft
     * @return
     */
    String publish(Nft nft);

    /**
     * 查看nft列表
     *
     * @param pageNum
     * @param pageSize
     * @param categoryId
     * @return
     */
    List<Nft> list(Integer pageNum, Integer pageSize, Integer categoryId);

    /**
     * 收藏nft
     *
     * @param id nft主键
     * @return
     */
    Boolean collection(Integer id);

    /**
     * 获取收藏页的nft对象
     *
     * @param id
     * @return
     */
    CollectionNftVo getCollectionVoById(Integer id);

    /**
     * 查询用户的收藏列表
     *
     * @param categoryId
     * @return
     */
    List<CollectionNftVo> getCollectionList(Integer categoryId);
}
