package com.fzm.common.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.fzm.common.entity.AuthPerson;
import com.fzm.common.entity.User;
import com.fzm.common.params.LoginParam;

/**
 * @author tangtuo
 * @date 2021/6/23 15:14
 */
public interface UserService extends IService<User> {

    /**
     * 根据手机号查询用户信息
     *
     * @param username
     * @return
     */
    User loadUserByUsername(String username);

    /**
     * 登录
     *
     * @param param
     * @return
     */
    User login(LoginParam param);

    /**
     * 根据token获取用户信息
     *
     * @return
     */
    User getUserByToken();

    /**
     * 个人实名认证
     *
     * @param authPerson
     */
    Boolean personAuth(AuthPerson authPerson);

    /**
     * 修改头像
     *
     * @param avatar
     * @return
     */
    User uploadAvatar(String avatar);
}
