package com.fzm.common.service.impl;

import cn.dev33.satoken.stp.StpUtil;
import cn.fzm.chain.simplesdk.client.ParaChainClient;
import cn.hutool.core.collection.CollectionUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fzm.common.constant.RedisConstant;
import com.fzm.common.entity.Nft;
import com.fzm.common.entity.vo.CollectionNftVo;
import com.fzm.common.mapper.NftMapper;
import com.fzm.common.service.NftService;
import com.fzm.common.utils.JsonUtil;
import com.fzm.common.utils.RedisUtil;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

/**
 * @author tangtuo
 * @date 2021/6/30 15:55
 */
@Service
public class NftServiceImpl extends ServiceImpl<NftMapper, Nft> implements NftService {

    @Resource
    private ParaChainClient paraChainClient;

    @Resource
    RedisUtil redisUtil;

    @Resource
    private NftMapper nftMapper;

    @Override
    public String publish(Nft nft) {
        save(nft);
        //return paraChainClient.evmPublishNFT1155();
        return null;
    }

    @Override
    public List<Nft> list(Integer pageNum, Integer pageSize, Integer categoryId) {
        return nftMapper.list(pageNum, pageSize, categoryId);
    }

    @Override
    public Boolean collection(Integer id) {
        String key = RedisConstant.COLLECTION_USER_PREFIX + StpUtil.getLoginIdAsInt();
        // 如果用户收藏的nft已经存在列表里,那么就是取消收藏
        if (redisUtil.sIsMember(key, id.toString())) {
            return redisUtil.sRemove(key, id.toString()) == 1;
        } else {
            return redisUtil.sAdd(key, id.toString()) == 1;
        }
    }

    @Override
    public CollectionNftVo getCollectionVoById(Integer id) {
        return new CollectionNftVo(getById(id));
    }

    @Override
    public List<CollectionNftVo> getCollectionList(Integer categoryId) {
        String key = RedisConstant.COLLECTION_USER_PREFIX + StpUtil.getLoginIdAsInt();
        Set<String> set = redisUtil.setMembers(key);
        if (CollectionUtil.isEmpty(set)) {
            return new ArrayList<>();
        }
        List<Integer> ids = set.stream().map(s -> Integer.valueOf(s)).collect(Collectors.toList());
        List<Nft> nfts = nftMapper.selectBatchIds(ids);
        List<CollectionNftVo> list = nfts.stream().map(CollectionNftVo::new).collect(Collectors.toList());
        if (categoryId != null) {
            list = list.stream().filter(nft -> categoryId.equals(nft.getCategoryId())).collect(Collectors.toList());
        }
        return list;
    }
}
